/*
	Kotoran's Shadow, an Amstrad game for the CPC RetroDev Contest 2014
    Copyright (C) 2014  Kronoscide

	This file is part of Kotoran's Shadow.

    Kotoran's Shadow is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

void ChangeMusic(){

	if(Map == 0){
		Music = 1;
	} else if(Map > 0 && Map < 5){
		if(LastMap >= 5 || LastMap == 0){
			Music = 1;
		}
	}else{
		if(LastMap < 5){
			Music = 1;
		}
	}

}

void EndGame(unsigned char w){

	Win = w;
	State = STATE_END;
	Initialized = 0;

}

void DrawMap () {
	unsigned char X, Y;
	NumEnemies = 0;
	ChangeMusic();
	LastMap = Map;
	if(Map >=0 && Map <5){	
		cpc_SetInk(0,3);	
	}else{
		cpc_SetInk(0,1);
	}
	cpc_SetModo(0);
	for (Y = 0; Y < 11; Y++) {
		for (X = 0; X < 10; X++) {
			if (Maps[Map][Y][X] == 1) {
				cpc_PutSp(TileBloque, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			} else if (Maps[Map][Y][X] == 2) {
				cpc_PutSp(TileTree, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			}  else if (Maps[Map][Y][X] == 3) {
				cpc_PutSp(Casa32_1, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			}  else if (Maps[Map][Y][X] == 4) {
				cpc_PutSp(Casa32_2, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			}  else if (Maps[Map][Y][X] == 5) {
				cpc_PutSp(Casa32_3, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			}  else if (Maps[Map][Y][X] == 6) {
				cpc_PutSp(Casa32_4, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			}   else if (Maps[Map][Y][X] == 7) {
				cpc_PutSp(Casa48_1, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			}   else if (Maps[Map][Y][X] == 8) {
				cpc_PutSp(Casa48_2, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			}   else if (Maps[Map][Y][X] == 9) {
				cpc_PutSp(Casa48_3, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			}   else if (Maps[Map][Y][X] == 10) {
				cpc_PutSp(Casa48_4, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			}   else if (Maps[Map][Y][X] == 11) {
				cpc_PutSp(Casa48_5, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			}    else if (Maps[Map][Y][X] == 12) {
				cpc_PutSp(Casa48_6, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			} else if (Maps[Map][Y][X] == 51) {	// Vida
				if (Lives[Map] == 1) {
					cpc_PutSp(TileLife, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
				}
			} else if (Maps[Map][Y][X] == 54) {
				Enemies[Map][NumEnemies].X = (X << 3);
				Enemies[Map][NumEnemies].Y = (Y << 4) + 24;
				Enemies[Map][NumEnemies].Height = 16;
				Enemies[Map][NumEnemies].Width = 8;
				
				Enemies[Map][X].Lives = 1 + (rand() & 3);
				Enemies[Map][NumEnemies].Lives = 1 + (rand() & 3);
				Enemies[Map][NumEnemies].left = (rand() & 3);
			    if (Enemies[Map][NumEnemies].left == 3) Enemies[Map][NumEnemies].left = 2; 
				Enemies[Map][NumEnemies].up = (rand() & 3);
				if (Enemies[Map][NumEnemies].up == 3) Enemies[Map][NumEnemies].up = 2; 
				Enemies[Map][NumEnemies].inicialX = Enemies[Map][NumEnemies].X;
				Enemies[Map][NumEnemies].inicialY = Enemies[Map][NumEnemies].Y;
				Enemies[Map][NumEnemies].valor = (rand() & 7);
				Enemies[Map][NumEnemies].oido = (rand() & 7);
				Enemies[Map][NumEnemies].estado = 0;
				Enemies[Map][NumEnemies].orientarse = 0;
				Enemies[Map][NumEnemies].contHuir = 0;
				
				NumEnemies++;
			} else if (Maps[Map][Y][X] > 54&& Maps[Map][Y][X] < 57) {
				Traps[Map].Height = 8;
				Traps[Map].Width = 4;
				Traps[Map].Enabled = 0;
				if(Maps[Map][Y][X] ==55){
					Traps[Map].Direction = KEY_LEFT;
					Traps[Map].X = (X << 3)+5;
					Traps[Map].Y = (Y << 4) + 28;
					Traps[Map].OriginalX = (X << 3)+5;
					Traps[Map].OriginalY = (Y << 4) + 28;
				}
				else{
					Traps[Map].Direction = KEY_DOWN;
					Traps[Map].X = (X << 3) + 2;
					Traps[Map].Y = (Y << 4) + 24;
					Traps[Map].OriginalX = (X << 3)+2;
					Traps[Map].OriginalY = (Y << 4) + 24;
				}
			} else if (Maps[Map][Y][X] == 57) {			
				cpc_PutSp(Corona, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24)); //Corona				
			}  else if (Maps[Map][Y][X] == 58) {			
				cpc_PutSp(TrampaI, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24)); //Trampa Izq
			}  else if (Maps[Map][Y][X] == 59) {			
				cpc_PutSp(TrampaA, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24)); //Trampa Aba				
			} else if (Maps[Map][Y][X] > 60 && Maps[Map][Y][X] < 66) {	// Interruptores
				if (Switches[Map]) {
					cpc_PutSp(TileSwitchOn, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
				} else {
					cpc_PutSp(TileSwitchOff, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
				}
			} else if (Maps[Map][Y][X] > 65 && Maps[Map][Y][X] < 71) {	// Puertas
				unsigned char I, DrawDoor = 1;
				for (I = 0; I < NUM_MAPS; I++) {
					if (Switches[I] == Maps[Map][Y][X] - 5) {
						Doors[Map] = 0;
						DrawDoor = 0;
					}
				}
				if (DrawDoor) cpc_PutSp(TileDoor, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			}
		}
	}
	
	Player.Attacking = 0;	// Para que no se dibuje al cambiar de mapa

}

void DrawHUD () {
	unsigned char I;
	for(I = 0; I < 10;I++){
		if(I==0){
			cpc_PutSp(TileHUD[0], 16, 8, cpc_GetScrAddress(I*8,0));
			cpc_PutSp(TileHUD2[0], 8, 4, cpc_GetScrAddress(I*4, 16));
			cpc_PutSp(TileHUD2[1], 8, 4, cpc_GetScrAddress(I*4+40, 16));
		}else if(I == 9){
			cpc_PutSp(TileHUD[2], 16, 8, cpc_GetScrAddress(I*8,0));
			cpc_PutSp(TileHUD2[1], 8, 4, cpc_GetScrAddress(I*4, 16));
			cpc_PutSp(TileHUD2[2], 8, 4, cpc_GetScrAddress(I*4+40, 16));
		}else{
			cpc_PutSp(TileHUD[1], 16, 8, cpc_GetScrAddress(I*8,0));
			cpc_PutSp(TileHUD2[1], 8, 4, cpc_GetScrAddress(I*4, 16));
			cpc_PutSp(TileHUD2[1], 8, 4, cpc_GetScrAddress(I*4+40, 16));
		}
		
		
		
	}
	
	if(Map >=0 && Map <5){	
		cpc_SetInk(0,3);	
	}else{
		cpc_SetInk(0,1);
	}
	
	for (I = 0; I < Player.Lives; I++) {
		cpc_PutSp(LifeHUD, 8, 4, cpc_GetScrAddress(2 + 4 * I, 12));
	}
	cpc_PrintGphStrXY("LIVES", 2, 2);
	
}

void RemoveLife () {
	EfecDano = 1;
	if (Player.Lives > 1) {
		Player.Lives--;
		cpc_PutSp(LifeHUDRemoved, 8, 4, cpc_GetScrAddress(2 + 4 * Player.Lives, 12));
	} else{
		EndGame(0);
	}
}

void AddLife () {
	EfecCogerVida = 1;
	if (Player.Lives < Player.MaxLives) {
		cpc_PutSp(LifeHUD, 8, 4, cpc_GetScrAddress(2 + 4 * Player.Lives, 12));
		Player.Lives++;
	}
}

void OpenDoors () {
	unsigned char X, Y;
	for (Y = 0; Y < 11; Y++) {
		for (X = 0; X < 10; X++) {
			if (Maps[Map][Y][X] == Switches[Map] + 5) {
				Doors[Map] = 0;
				cpc_PutSp(TileVoid, 16, 8, cpc_GetScrAddress((X << 3), (Y << 4) + 24));
			}
		}
	}
}

char TileCollision (unsigned char X, unsigned char Y, unsigned char IsPlayer) {
	char XAux = (X >> 3);
	char YAux = ((Y - 24) >> 4);
	
	char Collision = Maps[Map][YAux][XAux];
	if (Collision == 51) {	// Vida
		if (Lives[Map] == 1) {
			if (IsPlayer) {
				Lives[Map] = 0;
				cpc_PutSp(TileVoid, 16, 8, cpc_GetScrAddress((XAux << 3), (YAux << 4) + 24));
				AddLife();
			}
		} else {
			Collision = 0;
		}
	} else if (Collision == 52) {	// Puerta
		if (Doors[Map] == 0) {
			Collision = 0;
		}
	} else if (Collision == 53 && IsPlayer) {	// Interruptor
		if (Doors[Map] == 1) {
			Doors[Map] = 0;
			cpc_PutSp(TileSwitchOn, 16, 8, cpc_GetScrAddress((XAux << 3), (YAux << 4) + 24));
			OpenDoors();
		}
	} else if (Collision == 54) {
		Collision = 0;
	} else if (Collision == 55) {
		Collision = 0;
	} else if (Collision == 56) {
		Collision = 0;
	}  else if (Collision == 57) {
		Collision = 0;
		cpc_PutSp(TileVoid, 16, 8, cpc_GetScrAddress((XAux << 3), (YAux << 4) + 24));
		EndGame(1);
	} else if (Collision > 60 && Collision < 66 && IsPlayer) {	// Interruptores
		if (!Switches[Map]) {
			Switches[Map] = Collision;
			EfecBoton = 1;
			cpc_PutSp(TileSwitchOn, 16, 8, cpc_GetScrAddress((XAux << 3), (YAux << 4) + 24));
			OpenDoors();	// Por si la puerta esta en la misma habitacin
		}
	} else if (Collision > 65 && Collision < 71 ) {
		if (Doors[Map] == 0) {
			Collision = 0;
		}
	}
	
	return Collision;
}

char SpriteCollision (unsigned char A_X, unsigned char A_Y, unsigned char A_Width, unsigned char A_Height, unsigned char B_X, unsigned char B_Y, unsigned char B_Width, unsigned char B_Height) {
	return !(
		A_X > B_X + B_Width
		|| B_X > A_X + A_Width
		|| A_Y > B_Y + B_Height
		|| B_Y > A_Y + A_Height);
}

// Golpear al enemigo con un ataque.
void HitEnemy() {
	unsigned char I;
	for (I = 0; I < NumEnemies; I++) {
		if (Enemies[Map][I].Lives && SpriteCollision(Attack.X, Attack.Y, Attack.Width, Attack.Height, Enemies[Map][I].X, Enemies[Map][I].Y, Enemies[Map][I].Width, Enemies[Map][I].Height)) {
			Enemies[Map][I].Lives--;
			Player.Attacking = 0;
			EfecDanoEnemy = 1;
			cpc_PutSp(TileVoid2, 8, 4, cpc_GetScrAddress(Attack.X, Attack.Y));
			if (Enemies[Map][I].Lives == 0) {
				cpc_PutSp(TileVoid, 16, 8, cpc_GetScrAddress(Enemies[Map][I].X, Enemies[Map][I].Y));
			}
		}
	}
}

// IA del enemigo
char colisionEnemiIA(unsigned char Map, unsigned char I) {
	char ret = 0;
	
	if (SpriteCollision(Enemies[Map][I].X, Enemies[Map][I].Y, Enemies[Map][I].Width, Enemies[Map][I].Height, Enemies[Map][I^1].X, Enemies[Map][I^1].Y, Enemies[Map][I^1].Width, Enemies[Map][I^1].Height)) {
		ret = 1;
	}
	
	return(ret);
}

void mirarVertical(unsigned char Map, unsigned char  I, char izq) {
	char salir = 0;
	char cont = 0;
	char cont2 = 0;
	char arriba = 1;
	char miraA = 1;
	char exito = 0;
	
	char posX = (Enemies[Map][I].X) >> 3;
	char posY = (Enemies[Map][I].Y + 24) >> 4;
	
	if (izq == 1) {
		miraA = -1;
	} else {
		miraA = 1;
	}
	
	//arriba o abajo
	if (Enemies[Map][I].estado == 1) {
		if (posY > ((Enemies[Map][I].vistoY + 24) >> 4)) {
			arriba = -1;
		}
	} else if (Enemies[Map][I].estado == 3) {
		if (posY > ((Enemies[Map][I].sonidoY + 24) >> 4)) {
			arriba = -1;
		}
	} else if (Enemies[Map][I].estado == 4) {
		if (posY > ((Enemies[Map][I].inicialY + 24) >> 4)) {
			arriba = -1;
		}
	}
	
	while (exito == 0 && cont2 < 2) {
		while(salir == 0){
			if (posY + (cont * arriba) >= 0 && posY + (cont * arriba) < 11) {
				if (Maps[Map][posY + (cont * arriba)][posX] != 0) {
					salir = 1;
				} else {
					if(Maps[Map][posY + (cont * arriba)][posX + miraA] == 0){
						salir = 1;
						exito = 1;
						
						if (arriba == 1) {
							Enemies[Map][I].up = 0;
						} else {
							Enemies[Map][I].up = 1;
						}
					}
				}
			} else {
				salir = 1;
			}
			cont++;
		}
		arriba *= -1;
		cont2++;
	}
	
	if (exito == 0) {
		Enemies[Map][I].orientarse = 1;
	}
}

void mirarHorizontal(unsigned char Map, unsigned char  I, char arr) {
	char salir = 0;
	char cont = 0;
	char cont2 = 0;
	char izquierda = 1;
	char miraA = 1;
	char exito = 0;
	
	unsigned char posX = (Enemies[Map][I].X) >> 3;
	unsigned char posY = (Enemies[Map][I].Y + 24) >> 4;
	
	if (arr == 1) {
		miraA = -1;
	} else {
		miraA = 1;
	}
	
	//izquierda o derecha
	if (Enemies[Map][I].estado == 1) {
		if (posX > ((Enemies[Map][I].vistoX) >> 3)) {
			izquierda = -1;
		}
	} else if (Enemies[Map][I].estado == 3) {
		if (posX > ((Enemies[Map][I].sonidoX) >> 3)) {
			izquierda = -1;
		}
	} else if (Enemies[Map][I].estado == 4) {
		if (posX > ((Enemies[Map][I].inicialX) >> 3)) {
			izquierda = -1;
		}
	}
	
	while (exito == 0 && cont2 < 2) {
		while(salir == 0){
			if (posX + (cont * izquierda) >= 0 && posX + (cont * izquierda) < 10) {
				if (Maps[Map][posY][posX + (cont * izquierda)] != 0) {
					salir = 1;
				} else {
					if(Maps[Map][posY + miraA][posX + (cont * izquierda)] == 0){
						salir = 1;
						exito = 1;
						
						if (izquierda == 1) {
							Enemies[Map][I].left = 0;
						} else {
							Enemies[Map][I].left = 1;
						}
					}
				}
			} else {
				salir = 1;
			}
			cont++;
		}
		izquierda *= -1;
		cont2++;
	}
	
	if (exito == 0) {
		Enemies[Map][I].orientarse = 1;
	}
}

void oirDisparo(unsigned char Map){
	unsigned char I = 0;
	char rango = 2;
	char rango2 = -2;
	char diferencia = 0;
	char oido = 0;
	char agudeza = 0;
	unsigned char tiradaValor = 0;
	
	for (I = 0; I < NumEnemies; I++) {
		if (Enemies[Map][I].Lives && Enemies[Map][I].Y) {
			oido = 0;
			agudeza = rand() & 3;
			
			diferencia = (Enemies[Map][I].X >> 3) - (Player.X >> 3);
			if (diferencia < 0) diferencia *= -1;
			diferencia -= agudeza;
			if (diferencia < Enemies[Map][I].oido) {
				diferencia = ((Enemies[Map][I].Y + 24) >> 4) - ((Player.Y + 24) >> 4);
				if (diferencia < 0) diferencia *= -1;
				diferencia -= agudeza;
				if (diferencia < Enemies[Map][I].oido) {
					tiradaValor = rand() & 7;
					if (tiradaValor <= Enemies[Map][I].valor) {
						oido = 1;
					}
				}
			}
			
			if (oido == 1) {
				Enemies[Map][I].estado = 3;
				Enemies[Map][I].sonidoX = Player.X;
				Enemies[Map][I].sonidoY = Player.Y;
				
				diferencia = Enemies[Map][I].X - Enemies[Map][I].sonidoX;
				if (diferencia > rango) {
					Enemies[Map][I].left = 1;
				} else if (diferencia < rango2) {
					Enemies[Map][I].left = 0;
				} else {
					Enemies[Map][I].left = 2;
				}
				
				diferencia = Enemies[Map][I].Y - Enemies[Map][I].sonidoY;
				if (diferencia > rango) {
					Enemies[Map][I].up = 1;
				} else if (diferencia < rango2) {
					Enemies[Map][I].up = 0;
				} else {
					Enemies[Map][I].up = 2;
				}
			}
		}
	}
}

void verPersonaje(unsigned char Map, unsigned char I){
	char visto = 0;
	char tiradaValor = 0;
	char i = 0;
	char obstaculo = 0;
	
	if ((Enemies[Map][I].X >> 3) == (Player.X >> 3)) {
		visto = 1;
		
		if (((Enemies[Map][I].Y + 24) >> 4) > ((Player.Y + 24) >> 4)) {
			for (i = ((Enemies[Map][I].Y + 24) >> 4) - 1; i > ((Player.Y + 24) >> 4); i--) {
				if (Maps[Map][i][(Enemies[Map][I].X >> 3)] != 0) {
					i = -1;
					visto = 0;
				}
			}
		} else {
			for (i = ((Enemies[Map][I].Y + 24) >> 4) + 1; i < ((Player.Y + 24) >> 4); i++) {
				if (Maps[Map][i][(Enemies[Map][I].X >> 3)] != 0) {
					i = 100;
					visto = 0;
				}
			}
		}
	} else if (((Enemies[Map][I].Y + 24) >> 4) == ((Player.Y + 24) >> 4)) {
		visto = 1;
		
		if ((Enemies[Map][I].X >> 3) > (Player.X >> 3)) {
			for (i = (Enemies[Map][I].X >> 3) - 1; i > (Player.X >> 3); i--) {
				if (Maps[Map][((Enemies[Map][I].Y + 24) >> 4)][i] != 0) {
					i = -1;
					visto = 0;
				}
			}
		} else {
			for (i = (Enemies[Map][I].X >> 3) + 1; i < (Player.X >> 3); i++) {
				if (Maps[Map][((Enemies[Map][I].Y + 24) >> 4)][i] != 0) {
					i = 100;
					visto = 0;
				}
			}
		}
	}
	
	if (visto == 1) {
		Enemies[Map][I].contHuir = 0;
		if (Enemies[Map][I].estado != 2) {
			Enemies[Map][I].orientarse = 1;
			Enemies[Map][I].vistoX = Player.X;
			Enemies[Map][I].vistoY = Player.Y;
			
			if (Enemies[Map][I].estado != 1) {
				if (Enemies[Map][I].valor > 2) {
					Enemies[Map][I].estado = 1;
				} else {
					Enemies[Map][I].estado = 2;
				}
			}
		}
	}
}

void patrullar(unsigned char Map, unsigned char I){
	char num = 0;
	char distanciaMax = 0;
	char diferencia = 0;
	
	if ((Ticks & 127) == 0) {
		num = rand() & 7;
		if (num == 0 || num == 4 || num == 5) {
			Enemies[Map][I].left = 0;
		} else if (num == 2 || num == 7 || num == 6) {
			Enemies[Map][I].left = 1;
		} else {
			Enemies[Map][I].left = 2;
		}
		if (num == 1 || num == 4 || num == 6) {
			Enemies[Map][I].up = 0;
		} else if (num == 3 || num == 5 || num == 7) {
			Enemies[Map][I].up = 1;
		} else {
			Enemies[Map][I].up = 2;
		}
		
		distanciaMax = (rand() & 31) + (Enemies[Map][I].valor << 2);
		if (Enemies[Map][I].left == 0) {
			diferencia = Enemies[Map][I].X - Enemies[Map][I].inicialX;
			if (diferencia > distanciaMax) {
				Enemies[Map][I].left = 1;
			}
		} else if (Enemies[Map][I].left == 1) {
			diferencia = Enemies[Map][I].inicialX - Enemies[Map][I].X;
			if (diferencia > distanciaMax) {
				Enemies[Map][I].left = 0;
			}
		}
		if (Enemies[Map][I].up == 0) {
			diferencia = Enemies[Map][I].Y - Enemies[Map][I].inicialY;
			if (diferencia > distanciaMax) {
				Enemies[Map][I].up = 1;
			}
		} else if (Enemies[Map][I].up == 1) {
			diferencia = Enemies[Map][I].inicialY - Enemies[Map][I].Y;
			if (diferencia > distanciaMax) {
				Enemies[Map][I].up = 0;
			}
		}
	}
}

void atacar(unsigned char Map, unsigned char I){
	char rango = 2;
	char rango2 = -2;
	char cambiarEstado = 0;
	unsigned char tiradaValor = 0;
	char diferencia = 0;
	
	if (((Enemies[Map][I].X) >> 3) == ((Enemies[Map][I].vistoX) >> 3) && ((Enemies[Map][I].Y + 24) >> 4) == ((Enemies[Map][I].vistoY + 24) >> 4)) {
		cambiarEstado = 1;
	}
	
	if (Enemies[Map][I].orientarse == 1 && cambiarEstado == 0) {
		Enemies[Map][I].orientarse = 0;
		
		diferencia = Enemies[Map][I].X - Enemies[Map][I].vistoX;
		if (diferencia > rango) {
			Enemies[Map][I].left = 1;
		} else if (diferencia < rango2) {
			Enemies[Map][I].left = 0;
		} else {
			Enemies[Map][I].left = 2;
		}
		
		diferencia = Enemies[Map][I].Y - Enemies[Map][I].vistoY;
		if (diferencia > rango) {
			Enemies[Map][I].up = 1;
		} else if (diferencia < rango2) {
			Enemies[Map][I].up = 0;
		} else {
			Enemies[Map][I].up = 2;
		}
	}
	
	if (cambiarEstado == 1) {
		Enemies[Map][I].orientarse = 1;
		tiradaValor = rand() & 7;
		if (tiradaValor <= Enemies[Map][I].valor) {
			Enemies[Map][I].estado = 5;
		} else {
			Enemies[Map][I].estado = 4;
		}
	}
}

void huir(unsigned char Map, unsigned char I){
	if ((Ticks & 63) == 0) {
		if (((Enemies[Map][I].X + 4) >> 3) > ((Player.X + 4) >> 3)) {
			Enemies[Map][I].left = 0;
		} else if (((Enemies[Map][I].X + 4) >> 3) < ((Player.X + 4) >> 3)) {
			Enemies[Map][I].left = 1;
		} else {
			if (Enemies[Map][I].Y > 20 && !TileCollision(Enemies[Map][I].X, Enemies[Map][I].Y - 1, 0) && !TileCollision(Enemies[Map][I].X + Enemies[Map][I].Width - 1, Enemies[Map][I].Y - 1, 0)) {
				Enemies[Map][I].left = 0;
			} else {
				Enemies[Map][I].left = 1;
			}
		}
		
		if (((Enemies[Map][I].Y + 24 + 12) >> 4) > ((Player.Y + 24) >> 4)) {
			Enemies[Map][I].up = 0;
		} else if (((Enemies[Map][I].Y + 24 + 12) >> 4) < ((Player.Y + 24) >> 4)) {
			Enemies[Map][I].up = 1;
		} else {
			if (Enemies[Map][I].X < 72 && !TileCollision(Enemies[Map][I].X + Enemies[Map][I].Width, Enemies[Map][I].Y, 0) && !TileCollision(Enemies[Map][I].X + Enemies[Map][I].Width, Enemies[Map][I].Y + Enemies[Map][I].Height - 1, 0)) {
				Enemies[Map][I].up = 0;
			} else {
				Enemies[Map][I].up = 1;
			}
		}
		
		Enemies[Map][I].contHuir++;
		if (Enemies[Map][I].contHuir >= 3) {
			Enemies[Map][I].estado = 4;
		}
	}
}

void irDisparo(unsigned char Map, unsigned char I){
	char rango = 2;
	char rango2 = -2;
	char diferencia = 0;
	char cambiarEstado = 0;
	unsigned char tiradaValor = 0;
	
	//llegada al sonido
	if (((Enemies[Map][I].X + 8) >> 3) == ((Enemies[Map][I].sonidoX + 8) >> 3) && ((Enemies[Map][I].Y + 24 + 8) >> 4) == ((Enemies[Map][I].sonidoY + 24 + 8) >> 4)) {
		cambiarEstado = 1;
	}
	
	if (Enemies[Map][I].left == 2 && Enemies[Map][I].up == 2) {
		cambiarEstado = 1;
	}
	
	if (Enemies[Map][I].orientarse == 1 && cambiarEstado == 0) {
		Enemies[Map][I].orientarse = 0;
	
		diferencia = Enemies[Map][I].X - Enemies[Map][I].sonidoX;
		if (diferencia > rango) {
			Enemies[Map][I].left = 1;
		} else if (diferencia < rango2) {
			Enemies[Map][I].left = 0;
		} else {
			Enemies[Map][I].left = 2;
		}
		
		diferencia = Enemies[Map][I].Y - Enemies[Map][I].sonidoY;
		if (diferencia > rango) {
			Enemies[Map][I].up = 1;
		} else if (diferencia < rango2) {
			Enemies[Map][I].up = 0;
		} else {
			Enemies[Map][I].up = 2;
		}
	}
	
	if (cambiarEstado == 1) {
		tiradaValor = rand() & 7;
		
		if (tiradaValor <= Enemies[Map][I].valor) {
			Enemies[Map][I].estado = 5;
		} else {
			Enemies[Map][I].orientarse = 1;
			Enemies[Map][I].estado = 4;
		}
	}
}

void regresar(unsigned char Map, unsigned char I){
	char rango = 2;
	char rango2 = -2;
	char diferencia = 0;
	unsigned char tiradaValor = 0;
	
	//llegada al sonido
	if (((Enemies[Map][I].X + 8) >> 3) == ((Enemies[Map][I].inicialX + 8) >> 3) && ((Enemies[Map][I].Y + 24 + 8) >> 4) == ((Enemies[Map][I].inicialY + 24 + 8) >> 4)) {
		Enemies[Map][I].estado = 0;
	}
	
	if (Enemies[Map][I].left == 2 && Enemies[Map][I].up == 2) {
		Enemies[Map][I].estado = 5;
	}
	
	if (Enemies[Map][I].orientarse == 1 && Enemies[Map][I].estado == 4) {
		Enemies[Map][I].orientarse = 0;
	
		diferencia = Enemies[Map][I].X - Enemies[Map][I].inicialX;
		if (diferencia > rango) {
			Enemies[Map][I].left = 1;
		} else if (diferencia < rango2) {
			Enemies[Map][I].left = 0;
		} else {
			Enemies[Map][I].left = 2;
		}
		
		diferencia = Enemies[Map][I].Y - Enemies[Map][I].inicialY;
		if (diferencia > rango) {
			Enemies[Map][I].up = 1;
		} else if (diferencia < rango2) {
			Enemies[Map][I].up = 0;
		} else {
			Enemies[Map][I].up = 2;
		}
	}
}

void buscar(unsigned char Map, unsigned char I){
	char num = 0;
	
	if ((Ticks & 127) == 0) {
		num = rand() & 7;
		if (num == 0 || num == 4 || num == 5) {
			Enemies[Map][I].left = 0;
		} else if (num == 2 || num == 7 || num == 6) {
			Enemies[Map][I].left = 1;
		} else {
			Enemies[Map][I].left = 2;
		}
		if (num == 1 || num == 4 || num == 6) {
			Enemies[Map][I].up = 0;
		} else if (num == 3 || num == 5 || num == 7) {
			Enemies[Map][I].up = 1;
		} else {
			Enemies[Map][I].up = 2;
		}
	}
}

void EnemyAI () {
	unsigned char Dir = 0;
	unsigned char I;
	char cambioHorizontal = 0;
	
	for (I = 0; I < NumEnemies; I++) {
		if (Enemies[Map][I].Lives && Enemies[Map][I].Y) {
			cambioHorizontal = 0;
			
			//LOGICA
			verPersonaje(Map, I);
			
			switch (Enemies[Map][I].estado) {
				case 0: patrullar(Map, I); break;
				case 1: atacar(Map, I); break;
				case 2: huir(Map, I); break;
				case 3: irDisparo(Map, I); break;
				case 4: regresar(Map, I); break;
				case 5: buscar(Map, I); break;
			}
			
			//PATHFINDING
			if (Enemies[Map][I].left == 0) {
				if (Enemies[Map][I].X < 72 && !TileCollision(Enemies[Map][I].X + Enemies[Map][I].Width, Enemies[Map][I].Y, 0) && !TileCollision(Enemies[Map][I].X + Enemies[Map][I].Width, Enemies[Map][I].Y + Enemies[Map][I].Height - 1, 0)) {} else{
					Enemies[Map][I].left = 2;
					if (Enemies[Map][I].estado == 1 || Enemies[Map][I].estado == 3 || Enemies[Map][I].estado == 4) {
						mirarVertical(Map, I, 0);
					}
				}
			} else if (Enemies[Map][I].left == 1) {
				if (Enemies[Map][I].X > 0 && !TileCollision(Enemies[Map][I].X - 1, Enemies[Map][I].Y, 0) && !TileCollision(Enemies[Map][I].X - 1, Enemies[Map][I].Y + Enemies[Map][I].Height - 1, 0)) {} else {
					Enemies[Map][I].left = 2;
					if (Enemies[Map][I].estado == 1 || Enemies[Map][I].estado == 3 || Enemies[Map][I].estado == 4) {
						mirarVertical(Map, I, 1);
					}
				}
			}
			if (Enemies[Map][I].up == 0) {
				if (Enemies[Map][I].Y < 184 && !TileCollision(Enemies[Map][I].X, Enemies[Map][I].Y + Enemies[Map][I].Height, 0) && !TileCollision(Enemies[Map][I].X + Enemies[Map][I].Width - 1, Enemies[Map][I].Y + Enemies[Map][I].Height, 0)) {} else {
					Enemies[Map][I].up = 2;
					if (Enemies[Map][I].estado == 1 || Enemies[Map][I].estado == 3 || Enemies[Map][I].estado == 4) {
						cambioHorizontal = 1;
						mirarHorizontal(Map, I, 0);
					}
				}
			} else if (Enemies[Map][I].up == 1) {
				if (Enemies[Map][I].Y > 20 && !TileCollision(Enemies[Map][I].X, Enemies[Map][I].Y - 1, 0) && !TileCollision(Enemies[Map][I].X + Enemies[Map][I].Width - 1, Enemies[Map][I].Y - 1, 0)) {} else {
					Enemies[Map][I].up = 2;
					if (Enemies[Map][I].estado == 1 || Enemies[Map][I].estado == 3 || Enemies[Map][I].estado == 4) {
						cambioHorizontal = 1;
						mirarHorizontal(Map, I, 1);
					}
				}
			}
			if (cambioHorizontal == 1) {
				if (Enemies[Map][I].left == 0) {
					if (Enemies[Map][I].X < 72 && !TileCollision(Enemies[Map][I].X + Enemies[Map][I].Width, Enemies[Map][I].Y, 0) && !TileCollision(Enemies[Map][I].X + Enemies[Map][I].Width, Enemies[Map][I].Y + Enemies[Map][I].Height - 1, 0)) {} else{
						Enemies[Map][I].left = 2;
					}
				} else if (Enemies[Map][I].left == 1) {
					if (Enemies[Map][I].X > 0 && !TileCollision(Enemies[Map][I].X - 1, Enemies[Map][I].Y, 0) && !TileCollision(Enemies[Map][I].X - 1, Enemies[Map][I].Y + Enemies[Map][I].Height - 1, 0)) {} else {
						Enemies[Map][I].left = 2;
					}
				}
			}
			
			if (Enemies[Map][I].left == 2 && Enemies[Map][I].up == 2) {
				Enemies[Map][I].estado = 5;
			}
			
			//MOVIMIENTO
			if ((Ticks & 3) == 0) {
				if (Enemies[Map][I].left == 0) {
					Enemies[Map][I].X++;
					if (colisionEnemiIA(Map, I) == 1) {
						Enemies[Map][I].X--;
					}
				} else if (Enemies[Map][I].left == 1) {
					Enemies[Map][I].X--;
					if (colisionEnemiIA(Map, I) == 1) {
						Enemies[Map][I].X++;
					}
				}
			}
			if (Enemies[Map][I].up == 0) {
				Enemies[Map][I].Y++;
				if (colisionEnemiIA(Map, I) == 1) {
					Enemies[Map][I].Y--;
				}
			} else if (Enemies[Map][I].up == 1) {
				Enemies[Map][I].Y--;
				if (colisionEnemiIA(Map, I) == 1) {
					Enemies[Map][I].Y++;
				}
			}
			
			// QUITAR VIDA
			if ((Ticks & 127) == 0) {
				if (SpriteCollision(Player.X, Player.Y, Player.Width, Player.Height, Enemies[Map][I].X, Enemies[Map][I].Y, Enemies[Map][I].Width, Enemies[Map][I].Height)) {
					Enemies[Map][I].Lives = 0;
					cpc_PutSp(TileVoid, 16, 8, cpc_GetScrAddress(Enemies[Map][I].X, Enemies[Map][I].Y));
					RemoveLife();
				}
			}
		}
	}

}

void ResetTrap () {
	Traps[Map].Enabled = 0;
	cpc_PutSp(TileVoid2, 8, 4, cpc_GetScrAddress(Traps[Map].X, Traps[Map].Y));
	Traps[Map].X = Traps[Map].OriginalX;
	Traps[Map].Y = Traps[Map].OriginalY;
}

void TrapAI () {
	// Si hay una trampa en el mapa
	if (Traps[Map].Y) {
		if (Traps[Map].Enabled) {
			
			if(Traps[Map].Direction == KEY_LEFT && (Ticks & 3) == 0){
			
				if (!TileCollision(Traps[Map].X - 1, Traps[Map].Y, 0) && !TileCollision(Traps[Map].X - 1, Traps[Map].Y + Traps[Map].Width - 1, 0)) {
					
						Traps[Map].X--;
	
					if (SpriteCollision(Traps[Map].X, Traps[Map].Y, Traps[Map].Width, Traps[Map].Height, Player.X, Player.Y, Player.Width, Player.Height)) {
						RemoveLife();
						ResetTrap();
						EfecDano = 1;
					}
				} else {
					ResetTrap();
				}
			
			}else if(Traps[Map].Direction == KEY_DOWN && (Ticks & 1) == 0){
			
				if (!TileCollision(Traps[Map].X, Traps[Map].Y+1, 0) && !TileCollision(Traps[Map].X, Traps[Map].Y+1 + Traps[Map].Height - 1, 0)) {

						Traps[Map].Y++;
						
					if (SpriteCollision(Traps[Map].X, Traps[Map].Y, Traps[Map].Width, Traps[Map].Height, Player.X, Player.Y, Player.Width, Player.Height)) {
						RemoveLife();
						ResetTrap();
					}
				} else {
					ResetTrap();
				}
			
			}
			
		} else {
		
			if(TrapTicks > 200){
			
				if(Traps[Map].Direction == KEY_LEFT){
					if (Player.Y + Player.Height >= Traps[Map].Y && Player.Y <= Traps[Map].Y + Traps[Map].Height) {
						Traps[Map].Enabled = 1;
						EfecDispEnemy = 1;
						TrapTicks = 0;
					}
				}
				
				if(Traps[Map].Direction == KEY_DOWN){
					if (Player.X + Player.Width >= Traps[Map].X && Player.X <= Traps[Map].X + Traps[Map].Width) {
						Traps[Map].Enabled = 1;
						EfecDispEnemy = 1;
						TrapTicks = 0;
					}
				}
			}
			
		}
	}

}

void InitGame () {
	unsigned char I = 0;
	cpc_SetModo(0);
	LastMap = 0;
	Music = 0;
	First = 0;
	
	// Inicializar Player
	Player.X = 24;
	Player.Y = 48;
	Player.Width = 8;
	Player.Height = 16;
	Player.Direction = KEY_RIGHT;
	Player.Moving = 0;
	Player.Lives = 3;
	Player.MaxLives = 3;
	Player.Attacking = 0;
	
	Attack.Width = 4;
	Attack.Height = 8;
	
	MapsDoors[0].Up = 5; MapsDoors[0].Right = -1; MapsDoors[0].Down = -1; MapsDoors[0].Left = 1;
	MapsDoors[1].Up = 4; MapsDoors[1].Right = 0; MapsDoors[1].Down = -1; MapsDoors[1].Left = 2;
	MapsDoors[2].Up = 3; MapsDoors[2].Right = 1; MapsDoors[2].Down = -1; MapsDoors[2].Left = -1;
	MapsDoors[3].Up = -1; MapsDoors[3].Right = -1; MapsDoors[3].Down = 2; MapsDoors[3].Left = -1;
	MapsDoors[4].Up = -1; MapsDoors[4].Right = 5; MapsDoors[4].Down = 1; MapsDoors[4].Left = -1;
	MapsDoors[5].Up = 7; MapsDoors[5].Right = 6; MapsDoors[5].Down = 0; MapsDoors[5].Left = 4;
	MapsDoors[6].Up = -1; MapsDoors[6].Right = -1; MapsDoors[6].Down = -1; MapsDoors[6].Left = 5;
	MapsDoors[7].Up = 8; MapsDoors[7].Right = -1; MapsDoors[7].Down = 5; MapsDoors[7].Left = -1;
	MapsDoors[8].Up = -1; MapsDoors[8].Right = -1; MapsDoors[8].Down = 7; MapsDoors[8].Left = -1;
	
	for (I = 0; I < NUM_MAPS; I++) {
		Lives[I] = 1;
		Doors[I] = 1;
		Switches[I] = 0;
		Enemies[I][0].Lives = 2;
		Enemies[I][1].Lives = 2;
	}
	
	Map = 0;
	
	DrawMap();
	DrawHUD();
	Initialized = 1;
	Paused = 0;
}

void UpdateGame () {

	if(Paused){
		DrawMap();
		DrawHUD();
		Paused = 0;
	}

		
	TrapAI();
	
	if ((Ticks & 7) == 0) {
		EnemyAI();
	}
	
	
	if ((Ticks & 1) == 0) {	
		Player.Moving = 0;
		if (cpc_TestKey(KEY_UP) && Player.Y > 24) {
			if (!TileCollision(Player.X, Player.Y - 1, 1) && !TileCollision(Player.X + Player.Width - 1, Player.Y - 1, 1)) {
				Player.Y--;
				Player.Direction = KEY_UP;
				Player.Moving = 1;
				if ((Ticks & 63) == 0) Frame ^= 1;
				if (Player.Y == 24 && MapsDoors[Map].Up > -1) {
					Map = MapsDoors[Map].Up;
					Player.Y = 183;
					DrawMap();
					DrawHUD();
				}
			}

		} else if (cpc_TestKey(KEY_DOWN) && Player.Y < 184) {
			if (!TileCollision(Player.X, Player.Y + Player.Height, 1) && !TileCollision(Player.X + Player.Width - 1, Player.Y + Player.Height, 1)) {
				Player.Y++;
				Player.Direction = KEY_DOWN;
				Player.Moving = 1;
				if ((Ticks & 63) == 0) Frame ^= 1;
				if (Player.Y == 184 && MapsDoors[Map].Down > -1) {
					Map = MapsDoors[Map].Down;
					Player.Y = 25;
					DrawMap();
					DrawHUD();
				}
			}
		}
	}
		
	if ((Ticks & 7) == 0) {
		
		if (cpc_TestKey(KEY_RIGHT) && Player.X < 72) {
			if (!TileCollision(Player.X + Player.Width, Player.Y, 1) && !TileCollision(Player.X + Player.Width, Player.Y + Player.Height - 1, 1)) {
				Player.X++;
				Player.Direction = KEY_RIGHT;
				Player.Moving = 1;
				if ((Ticks & 63) == 0) Frame ^= 1;	
				if (Player.X == 72 && MapsDoors[Map].Right > -1) {
					Map = MapsDoors[Map].Right;
					Player.X = 1;
					DrawMap();
					DrawHUD();
				}
			}
		} else if (cpc_TestKey(KEY_LEFT) && Player.X > 0) {
			if (!TileCollision(Player.X - 1, Player.Y, 1) && !TileCollision(Player.X - 1, Player.Y + Player.Height - 1, 1)) {
				Player.X--;
				Player.Direction = KEY_LEFT;
				Player.Moving = 1;
				if ((Ticks & 63) == 0) Frame ^= 1;
				if (Player.X == 0 && MapsDoors[Map].Left > -1) {
					Map = MapsDoors[Map].Left;
					Player.X = 71;
					DrawMap();
					DrawHUD();
				}
			}
		}
	}
	
	// ATAQUE
	if (cpc_TestKey(KEY_SPACE) && !Player.Attacking) {
		if (posible) {
			posible = 0;
			if (Player.Direction == KEY_UP && !TileCollision(Player.X, Player.Y - 8, 0) && !TileCollision(Player.X + Player.Width - 1, Player.Y - 8, 0)) {
				Player.Attacking = 1;
				Attack.X = Player.X + 2;
				Attack.Y = Player.Y - 8;
				Attack.Direction = KEY_UP;
				EfecDisp = 1;
				AuxTicks = 0;
				oirDisparo(Map);
			} else if (Player.Direction == KEY_DOWN && !TileCollision(Player.X, Player.Y + 24, 0) && !TileCollision(Player.X + Player.Width - 1, Player.Y + 24, 0)) {
				Player.Attacking = 1;
				Attack.X = Player.X + 2;
				Attack.Y = Player.Y + 16;
				Attack.Direction = KEY_DOWN;
				EfecDisp = 1;
				AuxTicks = 0;
				oirDisparo(Map);
			} else if (Player.Direction == KEY_RIGHT && !TileCollision(Player.X + 12, Player.Y, 0) && !TileCollision(Player.X + 12, Player.Y + Player.Height - 1, 0)) {
				Player.Attacking = 1;
				Attack.X = Player.X + 8;
				Attack.Y = Player.Y + 4;
				Attack.Direction = KEY_RIGHT;
				EfecDisp = 1;
				AuxTicks = 0;
				oirDisparo(Map);
			} else if (Player.Direction == KEY_LEFT && !TileCollision(Player.X - 4, Player.Y, 0) && !TileCollision(Player.X - 4, Player.Y + Player.Height - 1, 0)) {
				Player.Attacking = 1;
				Attack.X = Player.X - 4;
				Attack.Y = Player.Y + 4;
				Attack.Direction = KEY_LEFT;
				EfecDisp = 1;
				AuxTicks = 0;
				oirDisparo(Map);
			}
		}
	} else if (Player.Attacking) {
	
		if ((Ticks & 1) == 0) {
			if (Attack.Direction == KEY_UP) {
			
				if (!TileCollision(Attack.X, Attack.Y - 1, 0) && !TileCollision(Attack.X + Attack.Width - 1, Attack.Y - 1, 0) && Attack.Y > 24) {
					Attack.Y--;
					HitEnemy();
				} else {
					Player.Attacking = 0;
					cpc_PutSp(TileVoid2, 8, 4, cpc_GetScrAddress(Attack.X, Attack.Y));
				}
				
			} else if (Attack.Direction == KEY_DOWN) {
			
				if (!TileCollision(Attack.X, Attack.Y + Attack.Height, 0) && !TileCollision(Attack.X + Attack.Width - 1, Attack.Y + Attack.Height, 0) && Attack.Y < 160) {
					Attack.Y++;
					HitEnemy();
				} else {
					Player.Attacking = 0;
					cpc_PutSp(TileVoid2, 8, 4, cpc_GetScrAddress(Attack.X, Attack.Y));
				}
				
			}
		}
		
		if ((Ticks & 3) == 0) {
			if (Attack.Direction == KEY_RIGHT) {
			
				if (!TileCollision(Attack.X + Attack.Width, Attack.Y, 0) && !TileCollision(Attack.X + Attack.Width, Attack.Y + Attack.Height - 1, 0) && Attack.X < 200) {
					Attack.X++;
					HitEnemy();
				} else {
					Player.Attacking = 0;
					cpc_PutSp(TileVoid2, 8, 4, cpc_GetScrAddress(Attack.X, Attack.Y));
				}
			
			} else if (Attack.Direction == KEY_LEFT) {
			
				if (!TileCollision(Attack.X - 1, Attack.Y, 0) && !TileCollision(Attack.X - 1, Attack.Y + Attack.Height - 1, 0) && Attack.X > 0) {
					Attack.X--;
					HitEnemy();
				} else {
					Player.Attacking = 0;
					cpc_PutSp(TileVoid2, 8, 4, cpc_GetScrAddress(Attack.X, Attack.Y));
				}
			
			}
		}
		
	}
	
	// Animacion
	if ((Ticks & 31) == 0 && !Player.Moving) Frame = 0;

	
	if ((Ticks & 63) == 0) {
		if (cpc_TestKey(KEY_ESCAPE)) {
			State = STATE_PAUSE;
			Initialized = 0;
		}
	}
	
}

void RenderGame () {
	unsigned char I;
	// Dibujar Player
	if (Player.Direction == KEY_UP) {
		cpc_PutSp(PlayerUp[Frame], Player.Height, Player.Width, cpc_GetScrAddress(Player.X, Player.Y));
	} else if (Player.Direction == KEY_RIGHT) {
		cpc_PutSp(PlayerRight[Frame], Player.Height, Player.Width, cpc_GetScrAddress(Player.X, Player.Y));
	} else if (Player.Direction == KEY_DOWN) {
		cpc_PutSp(PlayerDown[Frame], Player.Height, Player.Width, cpc_GetScrAddress(Player.X, Player.Y));
	} else if (Player.Direction == KEY_LEFT) {
		cpc_PutSp(PlayerLeft[Frame], Player.Height, Player.Width, cpc_GetScrAddress(Player.X, Player.Y));
	}

	// Dibujar Ataque
	if (Player.Attacking && (Ticks & 1) == 0) {
		cpc_PutSp(SpriteAttack, Attack.Height, Attack.Width, cpc_GetScrAddress(Attack.X, Attack.Y));
	}
	
	// Dibujar Enemigo
	if ((Ticks & 7) == 0) {
		for (I = 0; I < NumEnemies; I++) {
			if (Enemies[Map][I].Lives && Enemies[Map][I].Y) {
				cpc_PutSp(SpriteEnemy, Enemies[Map][I].Height, Enemies[Map][I].Width, cpc_GetScrAddress(Enemies[Map][I].X, Enemies[Map][I].Y));
			}
		}
	}
	
	// Dibujar Trampa
	if (Traps[Map].Enabled) {
		cpc_PutSp(SpriteAttack, Traps[Map].Height, Traps[Map].Width, cpc_GetScrAddress(Traps[Map].X, Traps[Map].Y));
	}
	
}