/*
	Kotoran's Shadow, an Amstrad game for the CPC RetroDev Contest 2014
    Copyright (C) 2014  Kronoscide

	This file is part of Kotoran's Shadow.

    Kotoran's Shadow is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

const unsigned char KEY_UP = 0;
const unsigned char KEY_RIGHT = 1;
const unsigned char KEY_DOWN = 2;
const unsigned char KEY_LEFT = 3;
const unsigned char KEY_ESCAPE = 4;
const unsigned char KEY_Z = 5;
const unsigned char KEY_X = 6;
const unsigned char KEY_SPACE = 7;
const unsigned char KEY_ENTER = 8;

const unsigned char STATE_INTRO = 0;
const unsigned char STATE_MENU = 1;
const unsigned char STATE_GAME = 2;
const unsigned char STATE_PAUSE = 3;
const unsigned char STATE_END = 4;

const unsigned char NUM_MAPS = 9;

typedef struct {
	char Up;
	char Right;
	char Down;
	char Left;
} _MapDoors;

typedef struct {
	unsigned char X;
	unsigned char Y;
	unsigned char Height;
	unsigned char Width;
	unsigned char Direction;
	unsigned char Moving;
	unsigned char Lives;
	unsigned char MaxLives;
	unsigned char Attacking;
} _Player;

typedef struct {
	unsigned char X;
	unsigned char Y;
	unsigned char Height;
	unsigned char Width;
	unsigned char Direction;
} _Attack;

typedef struct {
	unsigned char X;
	unsigned char Y;
	unsigned char Height;
	unsigned char Width;
	unsigned char Lives;
	unsigned char left;
	unsigned char up;
	
	unsigned char inicialX;
	unsigned char inicialY;
	unsigned char sonidoX;
	unsigned char sonidoY;
	unsigned char vistoX;
	unsigned char vistoY;
	
	unsigned char valor;
	unsigned char oido;
	unsigned char estado;
	unsigned char orientarse;
	unsigned char contHuir;
} _Enemy;

typedef struct {
	unsigned char X;
	unsigned char Y;
	unsigned char OriginalX;
	unsigned char OriginalY;
	unsigned char Height;
	unsigned char Width;
	unsigned char Enabled;
	unsigned char Direction;
} _Trap;

unsigned int Ticks = 0;
unsigned int TrapTicks = 0;
unsigned char Frame = 0;
unsigned char State;
unsigned char Initialized;
unsigned char Paused;
unsigned char Win;
unsigned char Exit = 0;
unsigned char Map;

_Player Player;
_Attack Attack;

// El nmero es NUM_MAPS
unsigned char Lives[9];
unsigned char Doors[9];
unsigned char Switches[9];
unsigned char LastMap;
unsigned char Music = 0;
unsigned char First = 1;
unsigned char AuxTicks = 0;
unsigned char VarAux = 0;
unsigned char posible = 0;
unsigned char EfecDano = 0;
unsigned char EfecCogerVida = 0;
unsigned char EfecDisp = 0;
unsigned char EfecBoton = 0;
unsigned char EfecDanoEnemy = 0;
unsigned char EfecDispEnemy = 0;
_Trap Traps[9];

unsigned char NumEnemies;
_Enemy	Enemies[9][2];

