/*
	Kotoran's Shadow, an Amstrad game for the CPC RetroDev Contest 2014
    Copyright (C) 2014  Kronoscide

	This file is part of Kotoran's Shadow.

    Kotoran's Shadow is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

_MapDoors MapsDoors[10];

/*
	0 - Vacio
	1 - Pared
	2 - Arbol
	3 - Casa 32_1
	4 - Casa 32_2
	5 - Casa 32_3
	6 - Casa 32_4
	
	7 - Casa 48_1
	8 - Casa 48_2
	9 - Casa 48_3
	10 - Casa 48_4
	11 - Casa 48_5
	12 - Casa 48_6
	
	51 - Vida
	52 - Puerta *SIN USAR
	53 - Interruptor *SIN USAR
	54 - Enemigo
	55 - Trampa Izq
	56 - Trampa Down
	57 - Corona
	58 - Canyon Izq
	59 - Canyon Aba
*/
/*
	61 - Interruptor 1
	62 - Interruptor 2
	63 - Interruptor 3
	64 - Interruptor 4
	65 - Interruptor 5
	66 - Puerta 1
	67 - Puerta 2
	68 - Puerta 3
	69 - Puerta 4
	70 - Puerta 5
*/

const unsigned char Maps[9][11][10] = {
	{//Map0
		{1, 1, 1, 1, 0, 0, 1, 1, 1, 1},
		{2, 0, 0, 0, 0, 0, 0, 0, 0, 2},
		{0, 0, 0, 0, 0, 0, 3, 4, 0, 2},
		{0, 0, 3, 4, 0, 0, 5, 6, 0, 2},
		{2, 0, 5, 6, 0, 0, 0, 0, 0, 2},
		{2, 0, 0, 0, 0, 0, 0, 0, 0, 2},
		{2, 0, 0, 0, 0, 7, 8, 9, 0, 2},
		{2, 3, 4, 0, 0, 10, 11, 12, 0, 2},
		{2, 5, 6, 0, 0, 0, 0, 0, 0, 2},
		{2, 0, 0, 0, 0, 0, 0, 0, 0, 2},
		{2, 2, 2, 2, 2, 2, 2, 2, 2, 2}
	},
	{//Map1
		{2, 2, 2, 0, 0, 2, 2, 2, 2, 1},
		{2, 0, 0, 0, 0, 0, 2, 2, 2, 2},
		{2, 0, 0, 0, 0, 0, 2, 0, 0, 0},
		{2, 0, 0, 2, 2, 2, 2, 0, 0, 0},
		{2, 0, 0, 2, 0, 0, 0, 0, 0, 2},
		{2, 0, 0, 2, 0, 0, 0, 0, 0, 2},
		{2, 0, 54, 2, 0, 0, 2, 2, 2, 2},
		{2, 0, 0, 2, 0, 0, 2, 0, 0, 2},
		{0, 0, 0, 0, 0, 0, 0, 55, 58, 2},
		{0, 0, 0, 0, 0, 0, 0, 0, 0, 2},
		{2, 2, 2, 2, 2, 2, 2, 2, 2, 2}
	},
	{//Map2
		{2, 2, 2, 2, 2, 2, 2, 0, 0, 2},
		{2, 0, 0, 0, 2, 0, 0, 0, 0, 2},
		{2, 0, 2, 0, 2, 0, 0, 2, 2, 2},
		{2, 54, 2, 0, 0, 0, 0, 0, 0, 2},
		{2, 0, 0, 0, 0, 2, 2, 2, 0, 2},
		{2, 0, 0, 2, 0, 0, 0, 2, 0, 2},
		{2, 0, 0, 2, 0, 2, 0, 2, 51, 2},
		{2, 0, 0, 2, 0, 2, 0, 2, 2, 2},
		{2, 0, 0, 2, 2, 2, 0, 0, 0, 0},
		{2, 0, 0, 0, 54, 0, 0, 0, 0, 0},
		{2, 2, 2, 2, 2, 2, 2, 2, 2, 2}
	},
	{//Map3
		{2, 2, 2, 2, 2, 2, 2, 2, 2, 2},
		{2, 0, 0, 0, 0, 0, 0, 0, 0, 2},
		{2, 0, 0, 0, 0, 0, 0, 0, 0, 2},
		{2, 0, 0, 0, 54, 0, 2, 0, 0, 2},
		{2, 0, 0, 0, 0, 0, 2, 0, 54, 2},
		{2, 0, 0, 0, 0, 0, 2, 0, 0, 2},
		{2, 0, 0, 0, 0, 0, 2, 0, 0, 2},
		{2, 0, 0, 2, 2, 2, 2, 0, 0, 2},
		{2, 0, 0, 0, 0, 0, 2, 0, 0, 2},
		{2, 0, 0, 0, 0, 61, 2, 0, 0, 2},
		{2, 2, 2, 2, 2, 2, 2, 0, 0, 2}
	},
	{//Map4
		{2, 2, 2, 2, 2, 2, 2, 2, 2, 1},
		{2, 62, 0, 0, 0, 0, 0, 55, 58, 1},
		{2, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{2, 0, 0, 0, 0, 2, 0, 0, 0, 1},
		{2, 0, 0, 0, 0, 2, 0, 0, 0, 1},
		{2, 0, 54, 0, 0, 2, 0, 0, 0, 66},
		{2, 0, 0, 0, 0, 2, 0, 0, 0, 66},
		{2, 0, 0, 2, 2, 2, 2, 2, 2, 1},
		{2, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{2, 0, 0, 0, 0, 0, 0, 0, 51, 1},
		{2, 2, 2, 0, 0, 2, 2, 2, 2, 1}
	},
	{//Map5
		{1, 68, 68, 1, 1, 1, 1, 1, 1, 1},
		{1, 0, 0, 1, 59, 0, 0, 0, 0, 1},
		{1, 0, 0, 1, 56, 0, 0, 0, 0, 1},
		{1, 0, 0, 1, 0, 0, 0, 1, 0, 1},
		{1, 0, 0, 1, 0, 0, 54, 1, 0, 1},
		{0, 0, 0, 1, 0, 0, 0, 1, 0, 0},
		{0, 0, 0, 1, 0, 0, 0, 1, 0, 0},
		{1, 1, 1, 1, 0, 0, 0, 1, 1, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 1, 1, 1, 0, 0, 1, 1, 1, 1}
	},
	{//Map6
		{1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
		{1, 63, 0, 0, 0, 0, 0, 0, 51, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 1, 1, 1, 0, 0, 1, 1, 1, 1},
		{1, 0, 0, 1, 0, 54, 0, 0, 0, 1},
		{0, 0, 0, 1, 0, 0, 0, 0, 0, 1},
		{0, 0, 0, 1, 0, 0, 0, 0, 0, 1},
		{1, 67, 67, 1, 1, 1, 1, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 54, 0, 0, 0, 0, 0, 1},
		{1, 1, 1, 1, 1, 1, 1, 1, 1, 1}
	},
	{//Map7
		{1, 1, 0, 0, 1, 1, 1, 1, 1, 1},
		{1, 0, 0, 0, 1, 59, 0, 0, 0, 1},
		{1, 1, 69, 69, 1, 56, 0, 0, 64, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 54, 0, 0, 0, 0, 0, 0, 1},
		{1, 1, 0, 0, 1, 1, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 1, 0, 0, 0, 1},
		{1, 0, 0, 1, 1, 1, 1, 1, 1, 1}
	},
	{//Map8
		{1, 1, 1, 1, 1, 1, 1, 1, 1, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 65, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 55, 58, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 0, 0, 0, 0, 1},
		{1, 1, 0, 0, 1, 1, 1, 70, 70, 1},
		{1, 0, 54, 0, 51, 1, 0, 0, 0, 1},
		{1, 0, 0, 0, 0, 1, 0, 57, 0, 1},
		{1, 1, 0, 0, 1, 1, 1, 1, 1, 1}
	}
};